<?php
/*
+---------------------------------------------------------------+
|        Unanswered Forum Posts Menu for e107 v7xx - by Father Barry
|
|        This module for the e107 .7+ website system
|        Copyright Barry Keal 2004-2009
|
|        Released under the terms and conditions of the
|        GNU General Public License (http://gnu.org).
|
+---------------------------------------------------------------+
*/
if (!defined('e107_INIT'))
{
    exit;
}

global $sql, $tp, $unanswered_obj, $unanswer_main,$unanswer_shortcodes, $unanswer_link, $unanswer_date, $unanswer_bullet, $unanswer_head;
if (!is_object($unanswered_obj))
{
    require_once(e_PLUGIN . 'unanswered/includes/unanswered_class.php');
    $unanswered_obj = new unanswered;
}
$cache_tag = "nq_unanswered";
// only cache if not random posts
// only cache if posts aging over 0 days, otherwise it won't show up today's unanswered posts
// Force retrieval to 1440
$cacheData = $e107cache->retrieve($cache_tag, 1440);
if ($unanswered_obj->unanswer_random == 0 && $unanswered_obj->unanswer_overdays > 0 && !empty($cacheData))
{
    echo $cacheData;
    return;
}

include_lan(e_PLUGIN . "unanswered/languages/" . e_LANGUAGE . "_unanswered.php");

require_once(e_HANDLER . "date_handler.php");
if (is_readable(THEME . "unanswered_template.php"))
{
    require(THEME . "unanswered_template.php");
}
else
{
    require(e_PLUGIN . "unanswered/templates/unanswered_template.php");
}

require_once(e_PLUGIN . "unanswered/includes/unanswered_shortcodes.php");
$unansfer_conv = new convert;
$unanswer_now = time() - (86400 * $unanswered_obj->unanswer_overdays);

$unanswer_limit = $unanswered_obj->unanswer_limit > 0?"limit 0," . $unanswered_obj->unanswer_num:"";
$unanswer_notbefore = $unanswered_obj->unanswer_notbefore > 0?"and thread_datestamp < " . $unanswer_now:"";
$unanswer_active = $unanswered_obj->unanswer_active == 1?"and thread_active=1":"";
if ($unanswered_obj->unanswer_random == 1)
{
    $unanswer_order = ' order by rand() ';
} elseif ($unanswered_obj->unanswer_random == 0 && $unanswered_obj->unanswer_order == 1)
{
    $unanswer_order = ' order by thread_datestamp desc ';
} elseif ($unanswered_obj->unanswer_random == 0 && $unanswered_obj->unanswer_order == 0)
{
    $unanswer_order = ' order by thread_datestamp asc ';
}
// *
// *
// *
$unanswer_ignore = "";
if ($unanswered_obj->unanswer_sticky == 1 && $unanswered_obj->unanswer_announce == 1)
{
    // if ignore sticky and announcements then thread_s =0
    $unanswer_ignore = "and thread_s = 0";
}
if ($unanswered_obj->unanswer_sticky == 1 && $unanswered_obj->unanswer_announce == 0)
{
    // if ignore sticky only then thread_s <> 1
    $unanswer_ignore = "and thread_s <>1";
} elseif ($unanswered_obj->unanswer_sticky == 0 && $unanswered_obj->unanswer_announce == 1)
{
    // if ignore announcements only then threads_<>2
    $unanswer_ignore = "and thread_s <>2";
}
$unanswer_sql = "
select count(thread_id) as unanswer_total from #forum_t
left join #forum on thread_forum_id=forum_id
where thread_total_replies=0 and thread_parent=0 $unanswer_notbefore $unanswer_active $unanswer_ignore and find_in_set(forum_class,'" . USERCLASS_LIST . "')";
$sql->db_Select_gen($unanswer_sql, false);
extract($sql->db_Fetch());

$unanswer_sql = "
select thread_id,thread_name,thread_datestamp from #forum_t
left join #forum on thread_forum_id=forum_id
where thread_total_replies=0 and thread_parent=0 $unanswer_notbefore $unanswer_active $unanswer_ignore and find_in_set(forum_class,'" . USERCLASS_LIST . "')
$unanswer_order $unanswer_limit";
if ($sql->db_Select_gen($unanswer_sql, false))
{
$unanswer_main=true;
    $unanswer_head = UNANSWER_002;
    $unanswer_bullet = "<img src='" . e_PLUGIN . "unanswered/images/unanswered_10.png' alt='' />";
    while ($unanswer_row = $sql->db_Fetch())
    {
        extract($unanswer_row);
        if ($unanswered_obj->unanswer_date > 0)
        {
            $unanswer_date = $unansfer_conv->convert_date($thread_datestamp, $unanswered_obj->unanswer_date == 1?"short":"long");
        }
        $unanswer_link = "<a href='" . e_PLUGIN . "forum/forum_viewtopic.php?$thread_id' >" . $tp->html_truncate($thread_name, $unanswered_obj->unanswer_maxlen, $unanswered_obj->unanswer_more) . "</a>";
        $unanswer_details .= $tp->parseTemplate($UNANSWER_MENU_DETAIL, false, $unanswer_shortcodes);
    } // while
}
else
{
    $unanswer_head = UNANSWER_003;
$unanswer_main=false;
}
// Now create the menu from the template
$unanswer_text = $tp->parseTemplate($UNANSWER_MENU_HEAD, false, $unanswer_shortcodes);
$unanswer_text .= $unanswer_details;
$unanswer_text .= $tp->parseTemplate($UNANSWER_MENU_FOOTER, false, $unanswer_shortcodes);
// Set up a new output buffer and render the menu
ob_start();
$ns->tablerender(UNANSWER_001, $unanswer_text, 'unanswered'); // Render the menu
$cache_data = ob_get_flush(); // Get the menu content, and display it
$e107cache->set($cache_tag, $cache_data); // Save to cache
